
//Zʂ̗ȂGLgB

#ifndef __TEXTURE_H__
#define __TEXTURE_H__

#include <gl/gl.h>
#include <gl/glut.h>

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <matrix.h>

#include <libpng/png.h>
#include <libjpeg/jpeglib.h>

#include <setjmp.h>

#include <windows.h>

#include <vector>
#include <string>

#pragma comment(lib,"zlib.lib")
#ifdef _DEBUG
#pragma comment(lib,"libpngd.lib")
#pragma comment(lib,"libjpegd.lib")
#else
#pragma comment(lib,"libpng.lib")
#pragma comment(lib,"libjpeg.lib")
#endif

int powlog2(int v)
{
	int i=0;
	v--;
	while(v){i++;v>>=1;}
	return 1<<i;
}

class Texture
{
protected:
	int *m_image;
	int m_id;
	int m_width,m_height,m_width2,m_height2;
public:
	union TARGB
	{
		unsigned int ARGB;
		struct
		{
			unsigned char R;
			unsigned char G;
			unsigned char B;
			unsigned char A;
		};
	};

public:
	Texture():m_image(0),m_id(0){}
//	Texture(const Texture &_t):m_image(0){Copy(_t);}
//	Texture &operator=(const Texture &_t){Copy(_t);return *this;}
	virtual ~Texture(){Release();}

/*	virtual void Copy(const Texture &_t)
	{
		if(&_t==this)return;
		if(_t.m_image==0)
		{
			Release();
			return;
		}
		Release();
		m_width=_t.m_width;m_height=_t.m_height;
		m_width2=_t.m_width2;m_height2=_t.m_height2;
		m_id=_t.m_id;
		m_image=new int[m_width2*m_height2];
		memcpy(m_image,_t.m_image,sizeof(int)*m_width2*m_height2);

		glBindTexture(GL_TEXTURE_2D,m_id);
	}*/

	//width,height͐̐BC[W}bv2nɕύXB
	virtual int *Create(int width,int height)
	{
		m_width2=powlog2(width);
		m_height2=powlog2(height);
		m_image=new int[m_width2*m_height2];
		m_width=width;
		m_height=height;

		//TextureoCh
		if(m_id==0)
			glGenTextures(1,(unsigned int*)&m_id);
		glBindTexture(GL_TEXTURE_2D,m_id);

		return m_image;
	}

	virtual void Release()
	{
		if(m_image)
		{delete[]m_image;m_image=0;}
	}

	//datŎw肵f[^Ŋmۗ̈Ŝ𖄂߂
	int Fill(int dat)
	{
		if(!m_image)return -1;

		int sz=m_width2*m_height2;
		for(int i=0;i<sz;i++)
		{
			m_image[i]=dat;
		}
		return 0;
	}

	class file
	{
	protected:
		FILE *fp;
	public:
		file(const char *fn,const char *attr)
		{fp=::fopen(fn,attr);}
		~file()
		{if(fp){::fclose(fp);fp=0;}}
		size_t read(void *buffer, size_t size, size_t count)
		{
			if(fp)
				return ::fread(buffer,size,count,fp);
			return 0;
		}
		FILE *get(){return fp;}
	};

	struct Jpeg_ErrorManager
	{
		jpeg_error_mgr m_field;
		jmp_buf m_buffer;
	};

	static void Jpeg_exitByLongJump(j_common_ptr pInfo)
	{
		Jpeg_ErrorManager *pErrManager=
			reinterpret_cast<Jpeg_ErrorManager*>(pInfo->err);
		longjmp(pErrManager->m_buffer,1);
	}

	int LoadFile(const char *fn)
	{
		int l=strlen(fn);

		if( (strcmp("jpg",fn+l-3)==0) || (strcmp("jpeg",fn+l-4)==0) )
		{
			return LoadJpeg(fn);
		}
		if(strcmp("png",fn+l-3)==0)
		{
			return LoadPng(fn);
		}

		return -1;
	}

	int LoadJpeg(const char *fn)
	{
		{
		file f(fn,"rb");
		if(!f.get())return -1;

		jpeg_decompress_struct jpg;
		jpeg_create_decompress(&jpg);

		Jpeg_ErrorManager ErrManager;
		jpg.err=jpeg_std_error(&ErrManager.m_field);
		ErrManager.m_field.error_exit=Texture::Jpeg_exitByLongJump;

		if(setjmp( ErrManager.m_buffer ))
		{
			jpeg_destroy_decompress(&jpg);
			return -1;
		}

		jpeg_stdio_src(&jpg,f.get());
		jpeg_read_header(&jpg,TRUE);
		jpeg_start_decompress(&jpg);

		int row=jpg.output_width*jpg.output_components;

		JSAMPARRAY ppBuf=(*jpg.mem->alloc_sarray)
			(reinterpret_cast<j_common_ptr>(&jpg),
			JPOOL_IMAGE,row,1);

		int *image=Create(jpg.output_width,jpg.output_height);
		Fill(0xff000000);
		int w2=m_width2,h2=m_height2;

		while(jpg.output_scanline<jpg.output_height)
		{
			jpeg_read_scanlines(&jpg,ppBuf,1);
			JSAMPROW pBuf=*ppBuf;

			for(unsigned int x=0;x<jpg.output_width;++x)
			{
				TARGB px;
				if(jpg.out_color_components==3)
				{
					px.R=*pBuf;++pBuf;
					px.G=*pBuf;++pBuf;
					px.B=*pBuf;++pBuf;
				}
				else
				{
					px.R=px.G=px.B=*pBuf;++pBuf;
				}
				px.A=255;
				*image=px.ARGB;++image;
			}
			image+=w2-jpg.output_width;
		}

		jpeg_finish_decompress(&jpg);
		jpeg_destroy_decompress(&jpg);
		}

		Set();

		return 0;
	}

	int LoadPng(const char *fn)
	{
		unsigned long width=0, height=0;
		int bit_depth=0, color_type=0, interlace_type;
		unsigned char **data;

		{
		//t@CJ
		file f(fn,"rb");
		if(!f.get())return -1;
		const size_t nSizeSig=8;
		const int nBytesSig=sizeof(unsigned char)*nSizeSig;
		unsigned char sig[nBytesSig];

		//PNGt@Cǂm߂	
		size_t nSizeReadSig=f.read(sig,sizeof(unsigned char),nSizeSig);
		if(nSizeReadSig!=nSizeSig)return -1;

		if(!png_check_sig(sig,nBytesSig))return -1;

		//png_struct\̍쐬
		png_structp     png_ptr;
		png_ptr = png_create_read_struct(                  
						PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
		if(!png_ptr)return -1;

		//png_info\̍쐬	
		png_infop       info_ptr;
		info_ptr = png_create_info_struct(png_ptr);
		if(!info_ptr)
		{
			png_destroy_read_struct(&png_ptr,NULL,NULL);
			return -1;
		}

		//G[p
		if(setjmp(png_ptr->jmpbuf))
		{
			if(data)
			{
				delete[]data;
			}
			png_destroy_read_struct(&png_ptr,NULL,NULL);
			return -1;
		}

		png_init_io(png_ptr, f.get());
		png_set_sig_bytes(png_ptr,nBytesSig);
		png_read_info(png_ptr, info_ptr);

		//IHDR`N擾
		png_get_IHDR(png_ptr, info_ptr, &width, &height,
						&bit_depth, &color_type, &interlace_type,
						NULL, NULL);

		//pbgn->RGBnɊg
		if(color_type==PNG_COLOR_TYPE_PALETTE ||
			(color_type==PNG_COLOR_TYPE_GRAY && bit_depth<8) ||
			png_get_valid(png_ptr,info_ptr,PNG_INFO_tRNS))
		{
			png_set_expand(png_ptr);
		}

		//16rbg->8rbgɗƂ
		if(bit_depth==16)
		{
			png_set_strip_16(png_ptr);
		}

		//O[XP[->RGBɊg
		if(color_type==PNG_COLOR_TYPE_GRAY ||
			color_type==PNG_COLOR_TYPE_GRAY_ALPHA)
		{
			png_set_gray_to_rgb(png_ptr);
		}

		//`lꍇ̓l255
		if(color_type!=PNG_COLOR_TYPE_GRAY_ALPHA &&
			color_type!=PNG_COLOR_TYPE_RGB_ALPHA)
		{
			png_set_filler(png_ptr,255,PNG_FILLER_AFTER);
		}

		//␳
		const double gammaLUT=1.0;
		const double gammaCRT=2.2;
		double dispExp=gammaLUT*gammaCRT;
		double gammaFile=0.0;
		if(png_get_gAMA(png_ptr,info_ptr,&gammaFile))
		{
			png_set_gamma(png_ptr,dispExp,gammaFile);
		}

		png_read_update_info(png_ptr,info_ptr);
		
		//摜̈쐬
		int *image=Create(width,height);
		Fill(0xff000000);
		int w2=m_width2,h2=m_height2;

		data=new unsigned char*[height];

		for(int i=0;i<height;i++)
		{
			data[i]=(unsigned char*)&(image[i*w2]);
		}

		// 摜f[^ǂݍ
		png_read_image(png_ptr, data);

		//PNG̍\̉
		png_destroy_read_struct(&png_ptr,&info_ptr,NULL);
		}

		Set();

		return 0;
	}

	//̃TCYɂ
	int ScaleQ()
	{
		gluScaleImage(GL_RGBA,
			m_width2,m_height2,GL_UNSIGNED_BYTE,m_image,
			m_width2>>1,m_height2>>1,GL_UNSIGNED_BYTE,m_image);

		m_width2>>=1;m_height2>>=1;
		m_width>>=1;m_height>>=1;

		return 0;
	}

	void Set()
	{
		//C[Wݒ
		glTexImage2D
			(GL_TEXTURE_2D,0,4,m_width2,m_height2,
			0,GL_RGBA,GL_UNSIGNED_BYTE,m_image);

		//Nv
//		glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP);
//		glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);
		//JԂ
		glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
		glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);

		//jA⊮
		glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);

	}

	//̃eNX`ANeBuɂ
	void Activate()const{glBindTexture(GL_TEXTURE_2D,m_id);}

	int* GetImage()const{return m_image;}

	int GetWidth()const{return m_width;}
	int GetHeight()const{return m_height;}
	void SetWidth(int w){m_width=w;}
	void SetHeight(int h){m_height=h;}
	void SetSize(Vector2i &wh){m_width=wh.x;m_height=wh.y;}
	int GetID()const{return m_id;}
	Vector2f GetRatio()const
	{return Vector2f((float)m_width/m_width2,(float)m_height/m_height2);}
};


typedef Texture* pTex;



//DIBpGLpeNX`B
//SetɎԂ̂ŃA^C͔B
//DIBƂĂ邪ނTextpɋ߂B
class TextureDIB:public Texture
{
protected:
	int m_dc;
	int m_bmp;
	
public:

	TextureDIB():m_dc(0){}
	TextureDIB(const Texture &_t):Texture(_t),m_dc(0){}
	
	virtual ~TextureDIB()
	{if(m_dc){::DeleteDC((HDC)m_dc);m_dc=0;}Release();}
	
	//width,height͐̐BC[W}bv2nɕύXB
	virtual int *Create(int width,int height)
	{
		Release();

		if(!m_dc)
		{
			HDC hscreen;
			hscreen=::CreateDC("DISPLAY",0,0,0);
			m_dc=(int)::CreateCompatibleDC(hscreen);
			::DeleteDC(hscreen);
		}
	
		m_width2=powlog2(width);
		m_height2=powlog2(height);

		BITMAPINFO bi;
		bi.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
		bi.bmiHeader.biWidth=m_width2;  //
		bi.bmiHeader.biHeight=m_height2;//
		bi.bmiHeader.biPlanes=1;        //v[̐
		bi.bmiHeader.biBitCount=32;     //v[̐F
		bi.bmiHeader.biCompression=BI_RGB;
		bi.bmiHeader.biSizeImage=0;
		bi.bmiHeader.biXPelsPerMeter=0;
		bi.bmiHeader.biYPelsPerMeter=0;
		bi.bmiHeader.biClrUsed=0;
		bi.bmiHeader.biClrImportant=0;

		m_bmp=(int)::CreateDIBSection((HDC)m_dc,&bi,DIB_RGB_COLORS,(void**)&m_image,0,0);

		::SelectObject((HDC)m_dc,(HBITMAP)m_bmp);

		::SetBkMode((HDC)m_dc,TRANSPARENT);

		m_width=width;
		m_height=height;

		//TextureoCh
		if(!m_id)
			glGenTextures(1,(unsigned int*)&m_id);
		glBindTexture(GL_TEXTURE_2D,m_id);

		return m_image;
	}

	virtual void Release()
	{
		if(m_image)
		{
			::DeleteObject((HBITMAP)m_bmp);
			m_bmp=0;
			m_image=0;
		}
	}
	
	int GetDC()const{return m_dc;}

	int TextOut(int x,int y,const char *str,Vector2i *ext=0,int len=-1)
	{
		if(len<0)
		{
			len=strlen(str);
		}
		::TextOut((HDC)m_dc,x,y,str,len);
		if(ext)
		{
			SIZE sz;
			::GetTextExtentPoint32((HDC)m_dc,str,len,&sz);
			ext->x=sz.cx;
			ext->y=sz.cy;
		}
		return 0;
	}

	int SetTextColor(int col)
	{
		return ::SetTextColor((HDC)m_dc,col);
	}

	HGDIOBJ SelectObject(void *obj)
	{
		return ::SelectObject((HDC)m_dc,(HGDIOBJ)obj);
	}

};

class TextureManager
{
public:
	typedef std::vector<Texture*> Texturepv;
	typedef std::vector<std::string> stringv;
protected:
	Texturepv m_tex;
	stringv m_texname;
public:
	TextureManager()
	{
	}
	~TextureManager()
	{
		Release();
	}
	int Release()
	{
		for(int i=0;i<m_tex.size();++i)
		{
			delete m_tex[i];
		}
		return 0;
	}
	int Load(const char *fn)
	{
		for(int i=0;i<m_texname.size();i++)
		{
			if(strcmp(fn,m_texname[i].c_str())==0)
			{
				return i;
			}
		}
		Texture *t=new Texture;
		if(t->LoadFile(fn)!=0)
		{
			delete t;
			return -1;
		}
		m_tex.push_back(t);
		std::string n(fn);
		m_texname.push_back(n);
		return m_texname.size();
	}
	int Append(const char *name,Texture *texture)
	{
		for(int i=0;i<m_texname.size();i++)
		{
			if(strcmp(name,m_texname[i].c_str())==0)
			{
				return i;
			}
		}
		m_tex.push_back(texture);
		std::string n(name);
		m_texname.push_back(n);
		return m_texname.size();
	}
	Texture *GetTexture(int i)const
	{
		return m_tex[i];
	}
	std::string GetTextureName(int i)const
	{
		return m_texname[i];
	}
	void Activate(int i)const
	{
		m_tex[i]->Activate();
	}
};


#endif

