
#include <gl/glut.h>
#include "himogl.h"


#include <stdio.h>

class Camera
{
private:
	double theta;    //ʊp(ǂ猩邩)
	double alpha;    //Ίp(ォ猩邩猩邩)
	double dist;     //Jƌ_Ƃ̋
	double px,py,pz; //Jʒu
public:
	Camera()
	{
		theta=0;
		alpha=0;
		dist=80;
	}

	//J]
	void Move(int dx,int dy)
	{
		theta-=dx*0.005;
		alpha-=dy*0.005;
		Reflesh();
	}

	double GetAlpha(){return alpha;}
	double GetTheta(){return theta;}
	void GetPosition(double &x,double &y,double &z)
	{
		x=px;y=py;z=pz;
	}

	//J̐ݒglɑ
	void Reflesh()
	{
		if(alpha>3.14)alpha=3.14;
		if(alpha<0.01)alpha=0.01;
//		glMatrixMode(GL_MODELVIEW);
//		glLoadIdentity();
		px=dist*sin(theta)*sin(alpha);
		pz=dist*cos(theta)*sin(alpha);
		py=dist*cos(alpha);
		gluLookAt(
			px,  py,  pz,   // _
			0.0, 0.0, 0.0,  // ʒu
			0.0, 1.0, 0.0  // ̏̕
		);
	}

	void CalcRay(const Vector3d &cursor,Vector3d &pos,Vector3d &vec)
	{
		pos.x=px;pos.y=py;pos.z=pz;
		vec=cursor;
		vec.RotateX(alpha+PI/2);
		vec.RotateY(theta);
	}
};

Himo himo;
Camera camera;

int t=0;

//}EXhbOp
int tmp_mouse_x=-1000,tmp_mouse_y=0;
int mouse_x=0,mouse_y=0;
int mouse_left=0,mouse_right=0;




void animate()
{
	/* ĕ`悷 */
	glutPostRedisplay();
	himo.Update();

	t++;
}


void subdraw()
{
	glShadeModel(GL_SMOOTH);

	float light_position[]={cos(t*0.01)*100+20,30,sin(t*0.01)*100+50,1};
	glLightfv(GL_LIGHT0,GL_POSITION,light_position);
	glEnable(GL_LIGHT0);

	Vector3d light(light_position[0],light_position[1],light_position[2]);

	glEnable(GL_LIGHTING);
	
	glEnable(GL_LINE_SMOOTH);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
	glColor4f(1,0,0,1);

	himo.Draw(light);
}

void disp()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	//}EX̓_->C
	double scale=tan(45.0/2*PI/180.0)/300.0;
	Vector3d cursor((mouse_x-400)*scale,(mouse_y-300)*scale,1);
	Vector3d pos,vec;
	camera.CalcRay(cursor,pos,vec);
	vec*=80.0;

	himo.CrossRay(pos,vec);

/*	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(
		0.0, 0.0, 80.0,
		0.0, 0.0, 0.0,
		0.0, 1.0, 0.0
	);*/

	glEnable(GL_DEPTH_TEST);
	glViewport(0,0,800,600);
	glPushMatrix();
	glLoadIdentity();
//	glTranslatef(4,0,0);
	camera.Reflesh();
	subdraw();
	glPopMatrix();

/*	glClear(GL_DEPTH_BUFFER_BIT);

	glViewport(280,0,400,600);
	glPushMatrix();
	glLoadIdentity();
	glTranslatef(-4,0,0);
	camera.Reflesh();
	subdraw();
	glPopMatrix();*/


	//}EX̓_\
	glDisable(GL_DEPTH_TEST);

	Vector3d pp=pos+vec;

//	glViewport(0,0,400,600);
	glPushMatrix();
	glLoadIdentity();
//	glTranslatef(4,0,0);
	camera.Reflesh();
	glDisable(GL_LIGHTING);
	glPointSize(5);
	glEnable(GL_POINT_SMOOTH);
	glBegin(GL_POINTS);
	glColor4f(0,1,0,0.5);
//	glVertex3f(-(mouse_x-400)*scale*0.5-2,-(mouse_y-300)*scale,0);
//	glVertex3f(-(mouse_x+280-400)*scale*0.5+2,-(mouse_y-300)*scale,0);
	glVertex3f(pp.x,pp.y,pp.z);
	glEnd();
	glPopMatrix();


	glutSwapBuffers();
}

void mouse(int button, int state, int x, int y)
{
	if(button==GLUT_LEFT_BUTTON)
	{
		if(state==GLUT_DOWN)
		{
			mouse_left=1;

			himo.Capture(true);	
		}
		else
		{
			mouse_left=0;

			himo.Capture(false);
		}

	}
	if(button==GLUT_RIGHT_BUTTON)
	{
		if(state==GLUT_DOWN)//E{^
		{
			mouse_right=1;
			tmp_mouse_x=x;tmp_mouse_y=y;
		}
		else//E{^𗣂
		{
			mouse_right=0;
			camera.Move(x-tmp_mouse_x,y-tmp_mouse_y);
			tmp_mouse_x=-1000;
		}
	}
}
void mousemove(int x,int y)
{
	if(mouse_right)
	{
		camera.Move(x-tmp_mouse_x,y-tmp_mouse_y);
		tmp_mouse_x=x;tmp_mouse_y=y;
	}
	mouse_x=x;
	mouse_y=y;
}
void mousemovefree(int x,int y)
{
	mouse_x=x;
	mouse_y=y;
}

int main(int argc,char **argv)
{
	glutInit(&argc,argv);
	glutInitWindowPosition(100, 50);
	glutInitWindowSize(800, 600);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);

	glutCreateWindow("HimoGL");
	glutDisplayFunc(disp);
	glutIdleFunc(animate);
	glutMouseFunc(mouse);
	glutMotionFunc(mousemove);
	glutPassiveMotionFunc(mousemovefree);


	glutSetCursor(GLUT_CURSOR_NONE);


	glClearColor(0.95f,0.995f,1.00f,1.0f);
	glEnable(GL_DEPTH_TEST);

	himo.Init();

	glMatrixMode(GL_PROJECTION);
	gluPerspective(
		45,
		4.0/3.0,
		20,
		150
	);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	
	glEnable(GL_CULL_FACE);

	camera.Reflesh();

	float ambient[]={0.9,0.8,0.6,1.0};
	glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
	float emission[]={0.5,0.4,0.3,1.0};
	glMaterialfv(GL_FRONT,GL_EMISSION,emission);
	float diffuse[]={0.5,0.5,0.5,1.0};
	glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
	float shininess[]={0.1,0.1,0.1,1.0};
	glMaterialfv(GL_FRONT,GL_SHININESS,shininess);

	glutMainLoop();
	return 0;
}

